# coding: utf-8

"""
    MailSlurp API

    MailSlurp is an API for sending and receiving emails and SMS from dynamically allocated email addresses and phone numbers. It's designed for developers and QA teams to test applications, process inbound emails, send templated notifications, attachments, and more.  ## Resources  - [Homepage](https://www.mailslurp.com) - Get an [API KEY](https://app.mailslurp.com/sign-up/) - Generated [SDK Clients](https://docs.mailslurp.com/) - [Examples](https://github.com/mailslurp/examples) repository  # noqa: E501

    The version of the OpenAPI document: 6.5.2
    Contact: contact@mailslurp.dev
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from mailslurp_client.configuration import Configuration


class GenerateStructuredContentSmsOptions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'sms_id': 'str',
        'instructions': 'str',
        'output_schema': 'StructuredOutputSchema',
        'transform_id': 'str'
    }

    attribute_map = {
        'sms_id': 'smsId',
        'instructions': 'instructions',
        'output_schema': 'outputSchema',
        'transform_id': 'transformId'
    }

    def __init__(self, sms_id=None, instructions=None, output_schema=None, transform_id=None, local_vars_configuration=None):  # noqa: E501
        """GenerateStructuredContentSmsOptions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._sms_id = None
        self._instructions = None
        self._output_schema = None
        self._transform_id = None
        self.discriminator = None

        self.sms_id = sms_id
        self.instructions = instructions
        if output_schema is not None:
            self.output_schema = output_schema
        self.transform_id = transform_id

    @property
    def sms_id(self):
        """Gets the sms_id of this GenerateStructuredContentSmsOptions.  # noqa: E501

        SMS ID to read and pass to AI  # noqa: E501

        :return: The sms_id of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :rtype: str
        """
        return self._sms_id

    @sms_id.setter
    def sms_id(self, sms_id):
        """Sets the sms_id of this GenerateStructuredContentSmsOptions.

        SMS ID to read and pass to AI  # noqa: E501

        :param sms_id: The sms_id of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and sms_id is None:  # noqa: E501
            raise ValueError("Invalid value for `sms_id`, must not be `None`")  # noqa: E501

        self._sms_id = sms_id

    @property
    def instructions(self):
        """Gets the instructions of this GenerateStructuredContentSmsOptions.  # noqa: E501

        Optional instructions for the AI to follow. Try to be precise and clear. You can include examples and hints.  # noqa: E501

        :return: The instructions of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :rtype: str
        """
        return self._instructions

    @instructions.setter
    def instructions(self, instructions):
        """Sets the instructions of this GenerateStructuredContentSmsOptions.

        Optional instructions for the AI to follow. Try to be precise and clear. You can include examples and hints.  # noqa: E501

        :param instructions: The instructions of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :type: str
        """

        self._instructions = instructions

    @property
    def output_schema(self):
        """Gets the output_schema of this GenerateStructuredContentSmsOptions.  # noqa: E501


        :return: The output_schema of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :rtype: StructuredOutputSchema
        """
        return self._output_schema

    @output_schema.setter
    def output_schema(self, output_schema):
        """Sets the output_schema of this GenerateStructuredContentSmsOptions.


        :param output_schema: The output_schema of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :type: StructuredOutputSchema
        """

        self._output_schema = output_schema

    @property
    def transform_id(self):
        """Gets the transform_id of this GenerateStructuredContentSmsOptions.  # noqa: E501

        ID of transformer to apply  # noqa: E501

        :return: The transform_id of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :rtype: str
        """
        return self._transform_id

    @transform_id.setter
    def transform_id(self, transform_id):
        """Sets the transform_id of this GenerateStructuredContentSmsOptions.

        ID of transformer to apply  # noqa: E501

        :param transform_id: The transform_id of this GenerateStructuredContentSmsOptions.  # noqa: E501
        :type: str
        """

        self._transform_id = transform_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerateStructuredContentSmsOptions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GenerateStructuredContentSmsOptions):
            return True

        return self.to_dict() != other.to_dict()
